;Addition to MJCulross' really neat soundx
;
;Changed keypad routine for multiple keypresses
;by holding down keypad
;
;
;Ken Kaarvik
;
;Sept 7/99
;

	INCLUDE	"keypad.asm"

        SECTION "ken hack code",HOME

load_cart_ram::			;load sound regs on power up
	ld	a,$0A		;enable access to cart ram
	ld	[0],a

	ld	hl,$A000
	ld	de,val_FF10	;$FF10
	ld	bc,($FF3F-$FF10)
	call	mem_Copy

	ld	a,$00		;disable access to cart ram
	ld	[0],a

	ret

save_cart_ram::			;save sound regs when select pressed
	ld	a,$0A		;enable access to cart ream
	ld	[0],a

	ld	hl,val_FF10 	;$FF10
	ld	de,$A000
	ld	bc,($FF3F-$FF10)
	call	mem_Copy

	ld	a,$00		;disable access to cart ram
	ld	[0],a

	ret

button_read_hacked::
	call	pad_Read
	ld	a,[_PadData]
	cp	0
	jr	nz,.button_is_pushed

	ld	a,6				;was 6
	ld	[repeat_interval_timer],a

	ld	hl,repeat_delay_timer
	ld	[hl],30				;was 30

	ld	hl,debounce_timer
	ld	a,[hl]
	cp	0
	ret	z
	dec	[hl]
	ret

.button_is_pushed
	ld	hl,repeat_delay_timer
	ld	a,[hl]
	cp	0
	jp	z,.repeat_delay_timer_timed_out

	dec	[hl]
	
	ld	hl,debounce_timer
	ld	a,[hl]
	cp	0
	jp	z,.execute_button

	ret

.repeat_delay_timer_timed_out

	ld	hl,repeat_interval_timer
	ld	a,[hl]
	cp	0
	jp	z,.repeat_interval_timer_timed_out

	dec	[hl]

	ret

.repeat_interval_timer_timed_out

.execute_button
	ld	a,6
	ld	[debounce_timer],a

	ld	a,9
	ld	[repeat_interval_timer],a

	ld	a,[_PadData]
	ld	[button_debounced],a

	bit	2,a
	call	nz,save_cart_ram

	ld	a,[_PadData]
	bit	3,a
	call	nz,load_cart_ram

	call    button_actions

	ret

				
        SECTION "ken vars",BSS

repeat_delay_timer	ds	1
debounce_timer		ds	1
repeat_interval_timer	ds	1